using System;
using System.Windows.Forms;

class Set
{
	private Object[] items;
	public Set(int num)
	{
		items = new Object[num];
		for(int i = 0; i < num; ++i)
		{
			items[i] = 2*i;
		}
	}
	public delegate void Feedback(object Value, int item, int numItems);
	public void ShowItems(Feedback feedback)
	{
		for(int i = 0; i < items.Length; ++i)
		{
			if(feedback != null)
			{
				feedback(items[i], i + 1, items.Length);
			}
		}
	}
}

class App
{
	static void FeedbackToConsole(object Value, int item, int numItems)
	{
		Console.Write("Processing item {0} of {1}: {2}.\n", item, numItems, Value);
	}
	static void FeedbackToMsgBox(object Value, int item, int numItems)
	{
		MessageBox.Show(String.Format("Processing item {0} of {1}: {2}.\n", 
			                          item, numItems, Value));
	}
	static void Main()
	{
		Set setOfInts = new Set(5);

		setOfInts.ShowItems(new Set.Feedback(FeedbackToConsole));
		setOfInts.ShowItems(new Set.Feedback(FeedbackToMsgBox));
	}

}