using System;

[AttributeUsage(AttributeTargets.Class)]
public class LectionAttribute : System.Attribute
{
	private string _message;
	public string message
	{
		get {return _message;}
		set {_message = value;}
	}
	public LectionAttribute() {}
	public LectionAttribute(string message) 
	{
		this.message = message;
	}
}

[Lection("Tipa ura")]
public class Student
{}

[Lection(message = "Ili ne ura")]
public class Prepod
{}

public class MainClass
{
	public static void EchoLectionMessage(Object o)
	{
		Type objType = o.GetType();
		if(objType.IsDefined(typeof(LectionAttribute), false))
		{
			foreach(Object attribute in objType.GetCustomAttributes(false))
			{
				LectionAttribute la = attribute as LectionAttribute;

				if(la != null)
				{
					Console.WriteLine(la.message);
				}
			}
		}
	}
	public static void Main()
	{
		Student student = new Student();
		Prepod prepod = new Prepod();

		EchoLectionMessage(student);
		EchoLectionMessage(prepod);
	}
}
